unit ApiMspCxcExt;

interface
  // Chequeo de errores
  function ccGetLastErrorCode: Integer; stdcall;
  function ccGetLastErrorMessage(ErrorMessage: PChar): Integer; stdcall;
  procedure ccSetErrorHandling(ExceptionOnError, MessageOnException: Integer); stdcall;

  function SetDBCxc(DBHandle: Integer): Integer; stdcall;
  function SetDBMetadatos(DBHandle: Integer): Integer; stdcall;

  function NuevoCreditoCc(ConceptoCcId: Integer; Fecha, Folio: PChar;
    ClienteId: Integer; Descripcion: PChar; CobradorId: Integer; PLHandle: Integer): Integer; stdcall;
  function AplicaCreditoCc: Integer; stdcall;
  function RenglonCreditoImpuestoCc(ImpuestoId: Integer;
    Importe, Impuesto: Double): Integer; stdcall;
  function RenglonCreditoCc(TipoImporte: PChar; CargoId: Integer; FolioCargo: PChar;
    Importe, Impuesto, IvaRetenido, IsrRetenido, DsctoPpag: Double): Integer; stdcall;
  procedure AbortaDoctoCxc; stdcall;
  function GetDoctoCCId(var DoctoId: Integer): Integer;  stdcall;

  // Checar Compatibilidad
  function GetVersionApiCxcAsInteger: Integer; stdcall;
  procedure GetVersionApiCxcAsString(lVersion: PChar); stdcall;
  function ChecaCompatibilidadCxc(HdbMetadatos: Integer): Integer; stdcall;

  function GetImporteMonedaCliente(ClienteId: Integer; FormaCobroId: Integer;
    ImporteCobro: Double; Fecha: PChar; var Importe: Double): Integer; stdcall;

  function NuevoAnticipoCc(ConceptoCcId: Integer; Fecha, Folio: PChar;
    ClienteId: Integer; Referencia, Descripcion: PChar; CondPagoId: Integer;
    Importe: Double; ImpuestoId, PLHandle: Integer): Integer; stdcall;
  function AplicaAnticipoCc: Integer; stdcall;
const
  ApiMsp  = 'ApiMicrosip.dll';

implementation
  // Chequeo de errores
  function ccGetLastErrorCode; external ApiMsp;
  function ccGetLastErrorMessage; external ApiMsp;
  procedure ccSetErrorHandling; external ApiMsp;

  function SetDBCxc; external ApiMsp;
  function SetDBMetadatos; external ApiMsp;

  function NuevoCreditoCc; external ApiMsp;
  function RenglonCreditoImpuestoCc; external ApiMsp;
  function RenglonCreditoCc; external ApiMsp;
  function AplicaCreditoCc; external ApiMsp;
  procedure AbortaDoctoCxc; external ApiMsp;
  function GetDoctoCCId; external ApiMsp;

  // Checar Compatibilidad
  function GetVersionApiCxcAsInteger; external ApiMsp;
  procedure GetVersionApiCxcAsString; external ApiMsp;
  function ChecaCompatibilidadCxc; external ApiMsp;

  function GetImporteMonedaCliente; external ApiMsp;
  function NuevoAnticipoCc; external ApiMsp;
  function AplicaAnticipoCc; external ApiMsp;

end.
